#define Tone 250
short int i=0, aux=0, per0=0, per1=0, per2=0, per3=0, per4=0, per5=0, per6=0;
short int per7=0, j=0;
char key1, key2;
unsigned int cont1=0, cont2=0, pw1, pw2, var1=0, var2=0;

void set_up() {

  ANSEL  = 0;                     // Configure AN pins as digital
  ANSELH = 0;
  TRISC7_bit=1;
  TRISC6_bit=0;
  TRISB=0x80;
  RB0_bit=0;
  PORTB.b1=0;
  UART1_Init(9600);               // Initialize UART module at 9600 bps
  Delay_ms(100);
}

void jp() {
   UART1_Write(10);
   UART1_Write(13);
 }

 void alarm() {
 RB0_bit=1;
 delay_ms(Tone);
 RB0_bit=0;
 delay_ms(Tone);
}
void saving() {

per0=pw1/1000;
per1=(pw1/100)%10;
per2=(pw1/10)%10;
per3=pw1%10;
per4=pw2/1000;
per5=(pw2/100)%10;
per6=(pw2/10)%10;
per7=pw2%10;
if(aux<=1){
jp();
UART1_Write('D');
UART1_Write('O'); //I don't use write_text function because there is a bug there.
UART1_Write('N');
UART1_Write('E');
jp();
EEPROM_Write(0x02,per0);
EEPROM_Write(0x04,per1);
EEPROM_Write(0x06,per2);
EEPROM_Write(0x08,per3);
EEPROM_Write(0x0A,per4);
EEPROM_Write(0x0B,per5);
EEPROM_Write(0x0C,per6);
EEPROM_Write(0x0D,per7);
delay_ms(1000);
}
else  {
UART1_Write_Text("....!Cancelled");
delay_ms(1000);
}
j=2;
jp();
UART1_Write_Text("Return ");
UART1_Write_Text("Motor Control");
jp();
}

void ch_password()  {
aux=0;
pw2=0;
pw1=0;
i=0;
j=1;
jp();
while (j==1){
  if (UART1_Data_Ready() == 1) {
     key2 = UART1_Read();
     UART1_Write(key2);
  switch (key2){
  case '0': i=0;   break;
  case '1': i=1;   break;
  case '2': i=2;   break;
  case '3': i=3;   break;
  case '4': i=4;   break;
  case '5': i=5;   break;
  case '6': i=6;   break;
  case '7': i=7;   break;
  case '8': i=8;   break;
  case '9': i=9;   break;
  case 'X': aux=2; saving(); break;
  }
  if(aux==0)pw1=10*pw1+i;
  if(pw1>9999) pw1=pw1/10, aux++;
  if(aux==1)pw2=10*pw2+i;
  if(pw2>9999) pw2=pw2/10, saving();
  }
 }
}
void PASSWORD() {
 if((cont1==var1)||(Button(&PORTB,7,10,0))){//Direct access
    if((cont2==var2)||(Button(&PORTB,7,10,0))){
     jp();
     UART1_Write_Text("Authorized Access");
     jp();
     UART1_Write_Text("Motor Control");
     jp();
    a:
    if (UART1_Data_Ready() == 1) {          // if data is received
     key2 = UART1_Read();
     UART1_Write(key2);
     if(key2=='E')jp(), UART1_Write_Text("New Number"), ch_password();
     if(key2=='F')jp(), UART1_Write_Text("MOTOR OFF"), jp(),  PORTB.b1=0;
     if(key2=='O')jp(), UART1_Write_Text("MOTOR ON"),  jp(),  PORTB.b1=1;
    }
    goto a;
 }
}
  else {
  UART1_Write_Text("!Denied Access");
  jp();
  b:
   alarm();
  goto b;
 }
}
void main() {
set_up();
var1 = 1000*EEPROM_Read(0x02)+ 100*EEPROM_Read(0x04)+ 10*EEPROM_Read(0x06)+ EEPROM_Read(0x08);
var2 = 1000*EEPROM_Read(0x0A)+ 100*EEPROM_Read(0x0B)+ 10*EEPROM_Read(0x0C)+ EEPROM_Read(0x0D);
jp();
UART1_Write_Text("Accesss Number");
jp();

while (1) {
  if (UART1_Data_Ready() == 1) {    // if data is received
     key1 = UART1_Read();
     UART1_Write(key1);

  switch (key1){
  case '0': i=0;   break;
  case '1': i=1;   break;
  case '2': i=2;   break;
  case '3': i=3;   break;
  case '4': i=4;   break;
  case '5': i=5;   break;
  case '6': i=6;   break;
  case '7': i=7;   break;
  case '8': i=8;   break;
  case '9': i=9;   break;
  case 'X': i=0; aux=0; cont1=0; cont2=0; UART1_Write_Text("....!Write Again");
  jp(); break;
  }
  if(aux==0)cont1=10*cont1+i;
  if(cont1>9999) cont1=cont1/10, aux++;
  if(aux==1)cont2=10*cont2+i;
  if(cont2>9999) cont2=cont2/10, PASSWORD();

  }
 }
}
